import React, { useState, useRef, useEffect } from "react";
import { makeStyles } from '@material-ui/core/styles';
import AddIcon from '@material-ui/icons/Add';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemText from '@material-ui/core/ListItemText';
import Collapse from '@material-ui/core/Collapse';
import {APIContext} from "./callWrapper";
import {
  Link,
} from "react-router-dom";


// TODO: alles nach uncommittedState pattern anpassen. 
// schauen, was davon wirklich gebraucht wurde.
const CollapseList = (props) => {

  const client = React.useContext(APIContext);

  const useStyles = makeStyles((theme) => ({
    nested: {
        paddingLeft: theme.spacing(4),
      },
  }));

  const classes = useStyles();
  const [userCharts, setUserCharts] = React.useState([]);

  /**
   *  Loads all available charts for the logged in user.
   **/
  const loadCharts = () => {

    client.getCharts()
    .then((charts) => {
      /* gets the last 3 charts */
      setUserCharts(charts.slice(0,3));
    })
    .catch((error) => {
      console.log(error.response);
    });
  };

  /** 
   * Run only once on mount and use loadcharts() when it's neccessary, otherwise endless loop. 
   **/
  React.useEffect(() => {

      loadCharts();
  }, []);

  /**
   * Returns the last 3 charts as a clickable, collapsable chart-list. 
   * */
  return (<Collapse in={props.collapse} timeout="auto" unmountOnExit>
              <List component="div" disablePadding>
                {userCharts.map(chart => (<ListItem button className={classes.nested} key={chart.id} component={Link} to={{
            pathname: "/chart/"+chart.id,
            state: {}
          }}>
                  <ListItemText primary={chart.chart_name} />
                  </ListItem>))}
              </List>
            </Collapse>)
}

export default CollapseList;   