import React, {createRef, useEffect, useState} from 'react';
import './MainContent.css';
import {APIContext} from './callWrapper'
import ChartRender from "./ChartRender";

const IdentityGenerator = ({generatorArguments, parentSize, parentRef}) => {
  // Return the first argument unprocessed
  return (generatorArguments.obj)
}

const ChartGenerator = ({generatorArguments, parentSize, parentRef}) => {

  const [dimensions, setDimensions] = React.useState(undefined)
  let chartRender = <ChartRender chartID={generatorArguments.chartID} dimensions={dimensions}/>


  React.useEffect( () => {
    //Update sizes, redraw chart
    if(parentSize && parentRef.current) {
      setDimensions([parentRef.current.clientWidth, parentRef.current.clientHeight])
    }
  }, [parentSize])

  return chartRender
}

export const Generator = ({ generatorName, generatorArguments, parentSize, parentRef}) => {

  const generators = {
    "id" : IdentityGenerator,
    "chart": ChartGenerator,
  }

  const generateChildElement = () => {
    const generator = generators[generatorName]
    return React.createElement(generator, {generatorArguments:generatorArguments, parentSize:parentSize, parentRef:parentRef})
  }
  return (generateChildElement())
}