import React, {Fragment} from "react";
import {
    Box,
    Container,
    Row,
    Column,
    FooterLink,
    Heading,
    FooterHeading,
} from "./styles/FooterStyles";
import {Route, Routes} from "react-router-dom";
import IfisLogo from '../images/ifis_white.svg';
import PlaceholderComponent from "../PlaceholderComponent";

export function footerRoutes() {

    {/*TODO: Replace Placeholders with actual content*/}

    return [
      <Route path="/ziel" element={<PlaceholderComponent />} />,
      <Route path="/vision" element={<PlaceholderComponent />} />,
      <Route path="/foerderung" element={<PlaceholderComponent />} />,
      <Route path="/api" element={<PlaceholderComponent />} />,
      <Route path="/benutzung" element={<PlaceholderComponent />} />,
      <Route path="/mail" element={<PlaceholderComponent />} />,
      /*
           FIXME: Load Mailto-Link from config file>
          TODO: Add component
          */
      <Route path="/formular" eelelement={<PlaceholderComponent />} />,
      <Route path="/agb" element={<PlaceholderComponent />} />,
      <Route path="/impressum" element={<PlaceholderComponent />} />,
    ]
}

export const Footer = () => {
    return (
        <Box>
            <FooterHeading>
                Interaktive Visualisierung von Open Data
            </FooterHeading>
            <Container>
                <Row>
                    <Column>
                        <Heading>Information</Heading>
                        <FooterLink to={{
            pathname: "/ziel"
          }}>Ziel</FooterLink>
                        <FooterLink to={{
            pathname: "/vision"
          }}>Vision</FooterLink>
                        <FooterLink to={{
            pathname: "/foerderung"
          }}>Förderung</FooterLink>
                    </Column>
                    <Column>
                        <Heading>Hilfe</Heading>
                        <FooterLink to={{
            pathname: "/api"
          }}>API</FooterLink>
                        <FooterLink to={{
            pathname: "/benutzung"
          }}>Benutzung</FooterLink>
                    </Column>
                    <Column>
                        <Heading>Kontakt</Heading>
                        <FooterLink to={{
            pathname: "/mail", //FIXME: Load Mailto-Link from config file
          }}>Email</FooterLink>
                        <FooterLink to={{
            pathname: "/formular"
          }}>Formular</FooterLink>
                    </Column>
                    <Column>
                        <Heading>Legal</Heading>
                        <FooterLink to={{
            pathname: "/agb"
          }}>AGB's</FooterLink>
                        <FooterLink to={{
            pathname: "/impressum"
          }}>Impressum</FooterLink>
                    </Column>
                </Row>
            </Container>
        </Box>
    );
};