# IVOD Demonstrator
=====

## Usage

With docker daemon enabled run 

`./demonstrator/run --build`

to build and run the demonstator.
On subsequent runs 

`./demonstrator/run`

will run the currently build image

To export the image add the flag 

`--export`

to create a compressed docker image of the demonstrator as portable file
The image can then be loaded with docker load

## Funtionality

The demonstrator runs a WSGI application on the debug server inside docker.
Uploaded files are saved in `/tmp/demonstrator` on the container
Currently all sides are created by one base template that dynamically loads other templates depending on context (rendering, parameters)

The server provides the following endpoints:
1. `/` : The main landing page
2. `/submit` : POST only, upload a file and create a new visualisation; on success redirects to `/file/<handle>` where handle is the identifier for this upload
3. `/file/<handle>` : GET only, main page of a graph, contains selection of available visualisation
4. `/render/<handle>` : POST only, render a visualisation. Called from within `/file/<handle>` with AJAX
5. `/params/<handle>` : POST only, get the available parameters for selected visualisation
6. `/data/<handle>/<chart_type>` : GET only, get the processed visualisation data for visualisation `<chart_type>`
7. `/favicon.ico` : GET only : get the favicon, same as `/static/favicon.ico`
8. `/static/<filename>`: GET only: get statically served files (mostly those in folder `./demonstrator/static/`)